<template>
  <div class="AvatarClothing">
    <h3>{{ t('component.avatar.clothing') }}</h3>
    <span class="AvatarClothing__OptionLabel">
      {{ t('component.avatar.shirtType') }}
    </span>

    <ColorChooser
      v-model="config.shirtColor"
      class="AvatarClothing__OptionColor"
      :preferred="AVATAR_OPTIONS.shirtColors"
      allow-custom
    />

    <Dropdown
      v-model="config.shirtType"
      class="AvatarClothing__OptionType"
      :options="AVATAR_OPTIONS.shirtTypes"
      :option-label="getLabel"
      option-value="value"
    />

    <span class="AvatarClothing__Label">
      {{ t('component.avatar.hatType') }}
    </span>

    <ColorChooser
      v-model="config.hatColor"
      class="AvatarClothing__OptionColor"
      :preferred="AVATAR_OPTIONS.hatColors"
      allow-custom
    />

    <Dropdown
      v-model="config.hatType"
      class="AvatarClothing__OptionType"
      :options="AVATAR_OPTIONS.hatTypes"
      :option-label="getLabel"
      option-value="value"
    />

    <span class="AvatarClothing__Label">
      {{ t('component.avatar.glassesType') }}
    </span>

    <Dropdown
      v-model="config.glassesType"
      class="AvatarClothing__OptionType"
      :options="AVATAR_OPTIONS.glassesTypes"
      :option-label="getLabel"
      option-value="value"
    />

    <span class="AvatarClothing__Label">
      {{ t('component.avatar.earringType') }}
    </span>

    <Dropdown
      v-model="config.earring"
      class="AvatarClothing__OptionType"
      :options="AVATAR_OPTIONS.earringTypes"
      :option-label="getLabel"
      option-value="value"
    />
  </div>
</template>

<script lang="ts" setup>
import { AVATAR_OPTIONS, Option } from '@/components/avatar/AvatarOptions'
import { useI18n } from 'vue-i18n'
import Dropdown from 'primevue/dropdown/Dropdown.vue'
import { AvatarConfig } from '@/api'
import { computed } from 'vue'
import ColorChooser from '@/components/ColorChooser.vue'

const { t } = useI18n()

const props = defineProps<{
  modelValue: AvatarConfig
}>()

const emits = defineEmits<{
  /**
   * Updates configuration
   */
  (e: 'update:modelValue', value: AvatarConfig): void
}>()

const config = computed({
  get: () => props.modelValue,
  set: (value: AvatarConfig) => emits('update:modelValue', value),
})

/**
 * Get translated label
 */
function getLabel<T>(option: Option<T>) {
  return t(option.label)
}
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;

.AvatarClothing {
  display: grid;
  grid-template-columns: [label] 1fr [color] min-content [type] min-content;
  gap: v.$spacing v.$spacing-2;
  align-items: center;

  &__Option {
    &Label {
      grid-column: label;
    }

    &Color {
      grid-column: color;
    }

    &Type {
      grid-column: type;
    }
  }

  &__Color {
    display: block;
    width: 1rem;
    height: 1rem;
    border: 1px solid var(--surface-300);
    background-color: var(--option-color);
  }
}
</style>
